if FireHack then
	return;
end

ConsoleAddMessage("Loaded API.");
IsFireHackLoaded = 1;

-- Fix the Interface settings.
local InterfaceOptions_AddCategory_Real = InterfaceOptions_AddCategory;
InterfaceOptions_AddCategory = function (...)
	local issecure_Real = issecure;
	issecure = function ()
		return false;
	end
	
	InterfaceOptions_AddCategory_Real(...);
	issecure = issecure_Real;
end

function SignalEvent (Event, ...)
	if FireHack_OnEvent then
		FireHack_OnEvent(FireHack, Event, ...);
	end
end

local AuctionTimeHack = GetFHSetting("AuctionTimeHack");
if AuctionTimeHack == "" or AuctionTimeHack == true or AuctionTimeHack == "true" then
	AuctionTimeHack = true;
else
	AuctionTimeHack = false;
end

local ZoomHack = GetFHSetting("ZoomHack");
if ZoomHack == "" or ZoomHack == true or ZoomHack == "true" then
	ZoomHack = true;
	SetCVar("cameraDistanceMax", "500");
else
	ZoomHack = false;
	SetCVar("cameraDistanceMax", "15");
end

if not Object then
	Object = {};
end

PlayerObject = {};

local ClickToPortKey = nil;

if GetFHSetting then
	ClickToPortKey = tonumber(GetFHSetting("ClickToPortKey"));
	if not ClickToPortKey or ClickToPortKey == 0 then
		ClickToPortKey = 0x11; -- Left Ctrl
	end
end

TYPE_OBJECT = 0;
TYPE_ITEM = 1;
TYPE_CONTAINER = 2;
TYPE_UNIT = 3;
TYPE_PLAYER = 4;
TYPE_GAMEOBJECT = 5;
TYPE_DYNAMICOBJECT = 6;
TYPE_CORPSE = 7;

local ObjectClassifications = {
	"normal",
	"elite",
	"rareelite",
	"worldboss",
	"rare",
	"trivial",
};

--[[ Language List Fix --
local OGetLanguageByIndex = GetLanguageByIndex;
GetLanguageByIndex = function (Index)
	if Index == 1 then	
		return "Universal";
	else
		return OGetLanguageByIndex(Index - 1);
	end
end

local OGetNumLanguages = GetNumLanguages;
GetNumLanguages = function ()
	return OGetNumLanguages() + 1;
end]]

-- http://lua-users.org/wiki/SimpleLuaClasses
-- class.lua
-- Compatible with Lua 5.1 (not 5.0).
function class(base, init)
   local c = {}    -- a new class instance
   if not init and type(base) == 'function' then
      init = base
      base = nil
   elseif type(base) == 'table' then
    -- our new class is a shallow copy of the base class!
      for i,v in pairs(base) do
         c[i] = v
      end
      c._base = base
   end
   -- the class will be the metatable for all its objects,
   -- and they will look up their methods in it.
   c.__index = c

   -- expose a constructor which can be called by <classname>(<args>)
   local mt = {}
   mt.__call = function(class_tbl, ...)
   local obj = {}
   setmetatable(obj,c)
   if init then
      init(obj,...)
   else 
      -- make sure that any stuff from the base class is initialized!
      if base and base.init then
      base.init(obj, ...)
      end
   end
   return obj
   end
   c.init = init
   c.is_a = function(self, klass)
      local m = getmetatable(self)
      while m do 
         if m == klass then return true end
         m = m._base
      end
      return false
   end
   setmetatable(c, mt)
   return c
end

-- Enumerate objects
function EnumerateObjects (Function, Type)
	local Total = GetTotalObjects();
	local i = 1;
	while i <= Total do
		local ThisObject = GetObjectListEntry(i);
		if not Type or (Type and ThisObject:GetType() == Type) then
			if not Function(ThisObject) then
				return false;
			end
		end
		
		i = i + 1;
	end
	
	return true;
end

-- Get an entry of the object list
function GetObjectListEntry (Entry)
	return Object():init(IGetObjectListEntry(Entry));
end

-- Get an object from its GUID
function GetObjectFromGUID (GUID)
	return Object():init(GUID);
end

-- Get an object from a unit ID
function GetObjectFromUnitID (UnitID)
	return Object():init(UnitGUID(UnitID));
end

-- Get an object from a pointer
function GetObjectFromPointer (Pointer)
	return Object():init(IGetObjectFromPointer(Pointer));
end

Object = class();

-- Construct the object from its GUID
function Object:init (GUID)
	self.GUID = GUID;
	return self;
end

-- Get the object's GUID
function Object:GetGUID ()
	return self.GUID;
end

-- Get the object's health
function Object:GetHealth ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return UnitHealth("Internal");
end

-- Get the object's max health
function Object:GetMaxHealth ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return UnitHealthMax("Internal");
end

-- Get the object's power
function Object:GetPower ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return UnitPower("Internal");
end

-- Get the object's max power
function Object:GetMaxPower ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return UnitPowerMax("Internal");
end

-- Get the object's level
function Object:GetLevel ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return UnitLevel("Internal");
end

-- Get if the object is moving
function Object:IsMoving ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return GetUnitSpeed("Internal") > 0;
end

-- Get the object's speed
function Object:GetSpeed ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	return GetUnitSpeed("Internal");
end

-- Get the class of an object
function Object:GetClass ()
	self:SetAsUnitID("Internal");
	return UnitClass("Internal");
end

-- Invite the object to the player's group
function Object:InviteToGroup ()
	if self:GetType() == 4 then
		InviteUnit(self:GetName());
	else
		error("Invalid type of object.");
	end
	return;
end

-- Invite the object to the player's guild
function Object:InviteToGuild ()
	if self:GetType() == 4 then
		GuildInvite(self:GetName());
	else
		error("Invalid type of object.");
	end
	return;
end

-- Get the creature type and family of the object
function Object:GetCreatureInfo ()
	self:SetAsUnitID("Internal");
	return UnitCreatureType("Internal"), UnitCreatureFamily("Internal");
end

-- Get if the object is facing another object
function Object:IsFacing (Other)
	local X, Y, Z, Rotation = self:GetLocation();
	local OtherX, OtherY = Other:GetLocation();
	
	return ((X - OtherX) * math.cos(-Rotation)) - ((Y - OtherY) * math.sin(-Rotation)) < 0;
end

-- Get if the object is behind another object
function Object:IsBehind (Other)
	if Other == nil then
		error("Usage: IsBehind (Object)");
		return;
	end

	--[[local X, Y, Z, Rotation = Other:GetLocation();
	local OtherX, OtherY = self:GetLocation();
	
	return ((OtherX - X) * math.cos(-Rotation)) - ((OtherY - Y) * math.sin(-Rotation)) < 0;]]
	local PlayerX, PlayerY = Player:GetLocation();
	local X, Y, Z, Rotation = Other:GetLocation();
	
	if Other:GetType() == TYPE_UNIT and Other:GetTarget() and Other:GetTarget():Exists() then
		-- If the unit has a target then it's rotation will be incorrect, so we need to calculate the correct one.
		local tX, tY, tZ = Other:GetTarget():GetLocation();
		Rotation = (rad(atan2(Y - tY, X - tX)) + math.pi) % (math.pi * 2);
	end

	return ((PlayerX - X) * math.cos(-Rotation)) - ((PlayerY - Y) * math.sin(-Rotation)) < 0;
end

-- Get if the object is tapped
function Object:IsTapped ()
	self:SetAsUnitID("Internal");
	return UnitIsTapped("Internal") == 1;
end

-- Get if the object is tapped by the player
function Object:IsTappedByPlayer ()
	self:SetAsUnitID("Internal");
	return UnitIsTappedByPlayer("Internal") == 1;
end

-- Get if the object is tapped by something other
function Object:IsTappedByOther ()
	return self:IsTapped() == true and self:IsTappedByPlayer() == false;
end

-- Get the object's reaction towards another object
function Object:GetReaction (Other)
	if Other == nil then
		error("Usage: GetReaction (OtherObject)");
		return;
	end

	local Type1, Type2 = self:GetType(), Other:GetType();
	if (Type1 ~= 3 and Type2 ~= 4) and (Type2 ~= 3 and Type2 ~= 4) then
		error("Invalid type of object.");
		return nil;
	end
	
	self:SetAsUnitID("Internal");
	Other:SetAsUnitID("Internal2");
	return UnitReaction("Internal", "Internal2");
end

-- Turn the player towards the object
function Object:Face ()
	FaceLocation(self:GetLocation());
	return;
end

-- Get the point directly between 2 objects
function GetPointBetweenObjects (Object1, Object2, Distance)
	if Object1 == nil or Object2 == nil or Distance == nil then
		error("Usage: GetPointBetweenObjects (Object1, Object2, DistanceFromObject1)");
		return nil;
	end
	
	local X1, Y1, Z1 = Object1:GetLocation();
	local X2, Y2 = Object2:GetLocation();
	local Rotation = rad(atan2(Y2 - Y1, X2 - X1));
	return X1 + Distance * math.cos(Rotation), Y1 + Distance * math.sin(Rotation), Z1;
end

-- Proxy functions

-- Set a unit ID to reference the object
function Object:SetAsUnitID (UnitID)
	return ISetAsUnitID(self.GUID, UnitID);
end

-- Get the object's type.
function Object:GetType ()
	return IGetType(self.GUID);
end

-- Get the object's pointer.
function Object:GetPointer ()
	return IGetPointer(self.GUID);
end

-- Get the classification of the object
function Object:GetClassification ()
	return ObjectClassifications[IGetClassification(self.GUID) + 1];
end

-- Get the object's location
function Object:GetLocation ()
	return IGetLocation(self.GUID);
end

-- Set the object's location
function Object:SetLocation (X, Y, Z, Rotation)
	if self.GUID == Player.GUID and not GetSpectatorHack() then
		error("The player's location cannot be set.");
		return;
	end
	
	return ISetLocation(self.GUID, X, Y, Z, Rotation or select(4, Object:GetLocation()));
end

-- Return the object to its default location
function Object:SetToDefaultLocation ()
	return ISetToDefaultLocation(self.GUID);
end

-- Show a chat bubble above the object
function Object:ShowChatBubble (String, Type)
	return IShowChatBubble(self.GUID, String, Type);
end

-- Get the object's name
function Object:GetName ()
	return IGetName(self.GUID);
end

-- Target the object
function Object:Target ()
	if self:GetType() == 3 or self:GetType() == 4 then
		self:SetAsUnitID("Internal");
		return TargetUnit("Internal");
	else
		error("Invalid type of object.");
	end
	return;
end

-- Get the object's target
function Object:GetTarget ()
	if self.GUID == Player.GUID then
		return Object():init(UnitGUID("Target"));
	end
	
	return Object():init(IGetTarget(self.GUID));
end

-- Get the object's movement flags
function Object:GetMovementFlags ()
	return IGetMovementFlags(self.GUID);
end

-- Get a descriptor of the object as an integer
function Object:GetIntDescriptor (Descriptor)
	return IGetIntDescriptor(self.GUID, Descriptor);
end

-- Get a descriptor of the object as a byte
function Object:GetByteDescriptor (Descriptor)
	return IGetByteDescriptor(self.GUID, Descriptor);
end

-- Get a descriptor of the object as a float
function Object:GetFloatDescriptor (Descriptor)
	return IGetFloatDescriptor(self.GUID, Descriptor);
end

-- Set a descriptor of the object as an integer
function Object:SetIntDescriptor (Descriptor, Value)
	return ISetIntDescriptor(self.GUID, Descriptor, Value);
end

-- Set a descriptor of the object as a byte
function Object:SetByteDescriptor (Descriptor, Value)
	return ISetByteDescriptor(self.GUID, Descriptor, Value);
end

-- Set a descriptor of the object as a float
function Object:SetFloatDescriptor (Descriptor, Value)
	return ISetFloatDescriptor(self.GUID, Descriptor, Value);
end

-- Get a descriptor of the object as an int64
function Object:GetInt64Descriptor (Descriptor)
	return IGetInt64Descriptor(self.GUID, Descriptor);
end

-- Set a descriptor of the object as an int64
function Object:SetInt64Descriptor (Descriptor, Value)
	return ISetInt64Descriptor(self.GUID, Descriptor, Value);
end

-- Track the object on the minimap
function Object:Track (State)
	if State == true then
		return ITrackObject(self.GUID, 1);
	elseif State == false then
		return ITrackObject(self.GUID, 0);
	else
		return ITrackObject(self.GUID, 2);
	end
end

-- Set the object's display ID
function Object:SetDisplayID (DisplayID)
	return ISetDisplayID(self.GUID, DisplayID);
end

-- Get the object's default display ID
function Object:GetDefaultDisplayID ()
	return IGetDefaultDisplayID(self.GUID);
end

-- Set the object's mount's display ID
function Object:SetMountDisplayID (DisplayID)
	return ISetMountDisplayID(self.GUID, DisplayID);
end

-- Set the object's scale
function Object:SetScale (Scale)
	return ISetScale(self.GUID, Scale);
end

-- Get the object's display ID
function Object:GetDisplayID ()
	return IGetDisplayID(self.GUID);
end

-- Get the object's scale
function Object:GetScale ()
	return IGetScale(self.GUID);
end

-- Interact with the object
function Object:Interact ()
	return IObjectInteract(self.GUID);
end

-- Get the object's dynamic flags
function Object:GetDynamicFlags ()
	return IGetDynamicFlags(self.GUID);
end

-- Get if the object is lootable
function Object:IsLootable ()
	return IIsLootable(self.GUID);
end

-- Get if the object is interactable
function Object:IsInteractable ()
	return IIsInteractable(self.GUID);
end

-- Get if the object is skinnable
function Object:IsSkinnable ()
	return IIsSkinnable(self.GUID);
end

-- Get if the object is attackable
function Object:IsAttackable ()
	return IIsAttackable(self.GUID);
end

-- Get if the object can attack another object
function Object:CanAttack (Other)
	return ICanAttack(self.GUID, Other.GUID);
end

-- Get if the object is fleeing
function Object:IsFleeing ()
	return IIsFleeing(self.GUID);
end

-- Get if the object is player controlled
function Object:IsPlayerControlled ()
	return IIsPlayerControlled(self.GUID);
end

-- Get if the object is in combat
function Object:IsInCombat ()
	return IIsInCombat(self.GUID);
end

-- Get if the object is mounted
function Object:IsMounted ()
	return IIsMounted(self.GUID);
end

-- Get if the object is outdoors
function Object:IsOutdoors ()
	return IIsOutdoors(self.GUID);
end

-- Get if the object is submerged
function Object:IsSubmerged ()
	local X, Y, Z = Object:GetLocation();
	return TraceLine(X, Y, Z, X, Y, Z + 1, 0x10000);
end

function Object:GetBuff (...)
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return;
	end

	self:SetAsUnitID("Internal");
	return UnitBuff("Internal", ...);
end

function Object:GetDebuff (...)
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return;
	end

	self:SetAsUnitID("Internal");
	return UnitDebuff("Internal", ...);
end

-- Get an object's aura
function Object:GetAura (...)
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return;
	end
	
	if type(({...})[1]) == "string" then
		if self:GetBuff(...) then
			return self:GetBuff(...);
		else
			return self:GetDebuff(...);
		end
	else
		self:SetAsUnitID("Internal");
		return UnitAura("Internal", ...); 
	end
end

-- Cast on the object
function Object:CastSpellByID (ID)
	if ID == nil then
		error("Usage: CastSpellByID (ID)");
		return;
	end
	
	self:SetAsUnitID("Internal");
	CastSpellByID(ID, "Internal");
	
	if AreaSpellIsPending() == true then
		local X, Y, Z = self:GetLocation();
		CastAtLocation(X + math.random(-0.01, 0.01), Y + math.random(-0.01, 0.01), Z + math.random(-0.01, 0.01));
	end
	return;
end

function Object:GetNearbyEnemies (Distance)
	Distance = Distance or 8;
	local Nearby = {};
	
	EnumerateObjects(function (ThisObject)
		local Type = ThisObject:GetType();
		if (Type == 3 or Type == 4) and ThisObject:IsAttackable() and not ThisObject:IsDead() and ThisObject:GetDistance(self) <= Distance then
			tinsert(Nearby, ThisObject);
		end
		
		return true;
	end);
	
	return Nearby;
end

function Object:GetNearbyPlayers (Distance)
	Distance = Distance or 8;
	local Nearby = {};
	
	EnumerateObjects(function (ThisObject)
		local Type = ThisObject:GetType();
		if ThisObject:GetDistance(self) <= Distance then
			tinsert(Nearby, ThisObject);
		end
		
		return true;
	end, TYPE_PLAYER);
	
	return Nearby;
end

function Object:IsDead ()
	return self:GetHealth() == 0;
end

function Object:IsSpellInRange (Spell)
	return self:GetDistance() <= select(9, GetSpellInfo(Spell));
end

function Object:SendAsTarget ()
	ISendAsTarget(self.GUID);
end

-- Get the distance between 2 objects
function Object:GetDistance (Other)
	if Other == nil then
		Other = Player;
	end

	local X1, Y1, Z1 = self:GetLocation();
	local X2, Y2, Z2 = Other:GetLocation();
	
	return math.sqrt(((X2 - X1) ^ 2) + ((Y2 - Y1) ^ 2) + ((Z2 - Z1) ^ 2));
end

-- Cast on the object
function Object:CastSpellByName (Name)
	if Name == nil then
		error("Usage: CastSpellByName (Name)");
		return;
	end
	
	self:SetAsUnitID("Internal");
	CastSpellByName(Name, "Internal");
	
	if AreaSpellIsPending() == true then
		local X, Y, Z = self:GetLocation();
		CastAtLocation(X + math.random(-0.01, 0.01), Y + math.random(-0.01, 0.01), Z + math.random(-0.01, 0.01));
	end
	return;
end

-- Get if the object is in line of sight of another object
function Object:InLineOfSight (OtherObject, Increase)
	OtherObject = OtherObject or Player;
	local X1, Y1, Z1 = self:GetLocation();
	local X2, Y2, Z2 = OtherObject:GetLocation();
	return not TraceLine(X1, Y1, Z1 + (Increase or 2), X2, Y2, Z2 + (Increase or 2), 0x10);
end

-- Get the object's model's file name.
function Object:GetModelFileName ()
	return IGetModelFileName(self.GUID);
end

-- Set the camera to target the object
function Object:SetAsCameraTarget ()
	return ISetAsCameraTarget(self.GUID);
end

-- Get if the object exists
function Object:Exists ()
	return IExists(self.GUID);
end

-- Get if the object is mounted
function Object:IsMounted ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return;
	end
	
	-- Remember to update this offset for patches.
	return ReadInt(self:GetPointer() + 0xC10) ~= 0;
end

-- Get the object's combat reach
function Object:GetCombatReach ()
	local Type = self:GetType();
	if Type ~= 3 and Type ~= 4 then
		error("Invalid type of object.");
		return;
	end
	
	-- Remember to update this for patches
	return self:GetFloatDescriptor(0x110);
end

-- Constantly face the object.
function Object:ConstantFace ()
	return IConstantFace(self.GUID);
end

function GetAveragePositionOfObjects (Objects)
	local Total = #Objects;
	local X, Y, Z = 0, 0, 0;
	
	for Key, ThisObject in pairs(Objects) do
		if ThisObject then
			local ThisX, ThisY, ThisZ = ThisObject:GetLocation();
			if ThisX and ThisY then
				X = X + ThisX;
				Y = Y + ThisY;
				Z = Z + ThisZ;
			end
		end
	end
	
	X = X / Total;
	Y = Y / Total;
	Z = Z / Total;
	return X, Y, Z;
end

-- Construct the player object
function CreatePlayerObject ()
	Player = GetObjectFromUnitID("Player");
	
	repeat
		Index, Value = next(PlayerObject, Index);
		if Value then
			Player[Index] = Value;
		end
	until Index == nil;
	
	return Player;
end

-- Get the distance that the player has fallen
function GetDistanceFallen ()
	if IsFalling() == 1 then
		return IGetDistanceFallen();
	else
		return nil;
	end
end

-- Write an array of bytes
function WriteByteArray (Address, Bytes)
	if Address == nil or Bytes == nil then
		error("Usage: WriteByteArray (Address, Bytes)");
		return;
	end

	-- Need a better fucking way to do this.
	local LuaString = "IWriteByteArray(" .. Address;

	local Index = nil;
	repeat
		Index, Value = next(Bytes, Index);
		if type(Value) == "number" then
			LuaString = LuaString .. ", " .. Value;
		end
	until Index == nil;
	LuaString = LuaString .. ");";
	
	return loadstring(LuaString)();
end

-- Read an array of bytes
function ReadByteArray (Address, Length)
	return {IReadByteArray(Address, Length)};
end

-- Read a binary file
function ReadBinaryFile (Path)
	return {IReadBinaryFile(Path)};
end

-- Write a binary file
function WriteBinaryFile (Path, Bytes)
	if Path == nil or Bytes == nil then
		error("Usage: WriteBinaryFile (Path, Bytes)");
		return;
	end
	
	local LuaString = "IWriteBinaryFile(\"" .. Path .. "\"";
	
	local Index = nil;
	repeat
		Index, Value = next(Bytes, Index);
		if type(Value) == "number" then
			LuaString = LuaString .. ", " .. Value;
		end
	until Index == nil;
	LuaString = LuaString .. ");";
	
	return loadstring(LuaString)();
end

-- Get the files in a directory
function GetFilesInDirectory (Directory)
	return {IGetFilesInDirectory(Directory)};
end

-- Get the directorys in a directory
function GetSubDirectories (Directory)
	return {IGetSubDirectories(Directory)};
end

-- Set the state of the fly hack
function SetFlyHack (State)
	if State == true then
		ISetFlyHack(1);
	elseif State == false then
		ISetFlyHack(0);
	else
		ISetFlyHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of the hover hack
function SetHoverHack (State)
	if State == true then
		ISetHoverHack(1);
	elseif State == false then
		ISetHoverHack(0);
	else
		ISetHoverHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set M2 collision
function SetM2Collision (State)
	if State == true then
		ISetM2Collision(1);
	elseif State == false then
		ISetM2Collision(0);
	else
		ISetM2Collision(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set WMO collision
function SetWMOCollision (State)
	if State == true then
		ISetWMOCollision(1);
	elseif State == false then
		ISetWMOCollision(0);
	else
		ISetWMOCollision(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set terrain collision
function SetTerrainCollision (State)
	if State == true then
		ISetTerrainCollision(1);
	elseif State == false then
		ISetTerrainCollision(0);
	else
		ISetTerrainCollision(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set liquid collision
function SetLiquidCollision (State)
	if State == true then
		ISetLiquidCollision(1);
	elseif State == false then
		ISetLiquidCollision(0);
	else
		ISetLiquidCollision(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of the climb hack
function SetClimbHack (State)
	if State == true then
		ISetClimbHack(1);
	elseif State == false then
		ISetClimbHack(0);
	else
		ISetClimbHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of the water walk hack
function SetWaterWalkHack (State)
	if State == true then
		ISetWaterWalkHack(1);
	elseif State == false then
		ISetWaterWalkHack(0);
	else
		ISetWaterWalkHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of the obscure target hack
function SetObscureTargetHack (State)
	if State == true then
		ISetObscureTargetHack(1);
	elseif State == false then
		ISetObscureTargetHack(0);
	else
		ISetObscureTargetHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of the no knockback hack
function SetNoKnockbackHack (State)
	if State == true then
		ISetNoKnockbackHack(1);
	elseif State == false then
		ISetNoKnockbackHack(0);
	else
		ISetNoKnockbackHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of the moving loot hack
function SetMovingLootHack (State)
	if State == true then
		ISetMovingLootHack(1);
	elseif State == false then
		ISetMovingLootHack(0);
	else
		ISetMovingLootHack(2);
	end
	
	SignalEvent("HackStateChange");
end

-- Set the state of wireframe
function SetWireFrame (State)
	if State == true then
		return ISetWireFrame(1);
	elseif State == false then
		return ISetWireFrame(0);
	else
		return ISetWireFrame(2);
	end
end

-- Set the state of colliding rendering
function SetCollidingRendering (State)
	if State == true then
		return ISetCollidingRendering(1);
	elseif State == false then
		return ISetCollidingRendering(0);
	else
		return ISetCollidingRendering(2);
	end
end

-- Set a type of tracking
function SetTrackingState (Type, State)
	if State == true then
		return ISetTrackingState(Type, 1);
	elseif State == false then
		return ISetTrackingState(Type, 0);
	else
		return ISetTrackingState(Type, 2);
	end
end

-- Set M2 rendering
function SetM2Rendering (State)
	if State == true then
		return ISetM2Rendering(1);
	elseif State == false then
		return ISetM2Rendering(0);
	else
		return ISetM2Rendering(2);
	end
end

-- Set WMO rendering
function SetWMORendering (State)
	if State == true then
		return ISetWMORendering(1);
	elseif State == false then
		return ISetWMORendering(0);
	else
		return ISetWMORendering(2);
	end
end

-- Set terrain rendering
function SetTerrainRendering (State)
	if State == true then
		return ISetTerrainRendering(1);
	elseif State == false then
		return ISetTerrainRendering(0);
	else
		return ISetTerrainRendering(2);
	end
end

-- Set liquid rendering
function SetLiquidRendering (State)
	if State == true then
		return ISetLiquidRendering(1);
	elseif State == false then
		return ISetLiquidRendering(0);
	else
		return ISetLiquidRendering(2);
	end
end

-- Set M2 colors rendering
function SetM2Colors (State)
	if State == false then
		return ISetM2Colors(0);
	elseif State == true then
		return ISetM2Colors(1);
	else
		return ISetM2Colors(2);
	end
end

-- Set simple textures
function SetSimpleTextures (State)
	if State == false then
		return ISetSimpleTextures(0);
	elseif State == true then
		return ISetSimpleTextures(1);
	else
		return ISetSimpleTextures(2);
	end
end

-- Set the spectator hack
function SetSpectatorHack (State)
	if State == false then
		return ISetSpectatorHack(0);
	elseif State == true then
		return ISetSpectatorHack(1);
	else
		return ISetSpectatorHack(2);
	end
end

-- Turn the player towards a point
function FaceLocation (X, Y)
	local PlayerX, PlayerY = Player:GetLocation();
	if rad(atan2(Y - PlayerY, X - PlayerX)) < 0 then
		FaceDirection(rad(atan2(Y - PlayerY, X - PlayerX) + 360));
	else
		FaceDirection(rad(atan2(Y - PlayerY, X - PlayerX)));
	end
	
	return;
end

-- Get the distance between 2 points
function GetDistanceBetweenPoints (X1, Y1, Z1, X2, Y2, Z2)
	return math.sqrt(((X2 - X1) ^ 2) + ((Y2 - Y1) ^ 2) + ((Z2 - Z1) ^ 2));
end

local CommandCallbacks = {};

-- Set a command callback
function SetCommandCallback (Function)
	tinsert(CommandCallbacks, Function);
	return;
end

function RemoveCommandCallback (Function)
	repeat
		Index, Value = next(CommandCallbacks, Index);
		if Value == Function then
			tremove(CommandCallbacks, Index);
			return;
		end
	until Index == nil;
	return;
end

function BNSendWhisperHook (PresenceID, Message, ...)
	if Message:sub(0, 1) == "." or Message:sub(0, 1) == "," then
		return SendChatMessage(Message);
	else
		return BNSendWhisper(PresenceID, Message, ...);
	end
end

ChatEdit_SendText = function(editBox, addHistory)
	ChatEdit_ParseText(editBox, 1);

	local type = editBox:GetAttribute("chatType");
	local text = editBox:GetText();
	if ( strfind(text, "%s*[^%s]+") ) then
		text = SubstituteChatMessageBeforeSend(text);
		--BN_WHISPER FIXME
		if ( type == "WHISPER") then
			local target = editBox:GetAttribute("tellTarget");
			ChatEdit_SetLastToldTarget(target, type);
			SendChatMessageHook(text, type, editBox.languageID, target);
		elseif ( type == "BN_WHISPER" ) then
			local target = editBox:GetAttribute("tellTarget");
			local presenceID = BNet_GetPresenceID(target);
			if ( presenceID ) then
				ChatEdit_SetLastToldTarget(target, type);
				BNSendWhisperHook(presenceID, text);
			else
				local info = ChatTypeInfo["SYSTEM"]
				editBox.chatFrame:AddMessage(format(BN_UNABLE_TO_RESOLVE_NAME, target), info.r, info.g, info.b);
			end
		elseif ( type == "BN_CONVERSATION" ) then
			local target = tonumber(editBox:GetAttribute("channelTarget"));
			BNSendConversationMessage(target, text);
		elseif ( type == "CHANNEL") then
			SendChatMessageHook(text, type, editBox.languageID, editBox:GetAttribute("channelTarget"));
		else
			SendChatMessageHook(text, type, editBox.languageID);
		end
		if ( addHistory ) then
			ChatEdit_AddHistory(editBox);
		end
	end
end

function SendChatMessageHook (Message, Channel, Language, Type)
	if Message:sub(0, 1) == "," then
		Message = "." .. Message:sub(2);
	end

	for Key, Value in pairs(CommandCallbacks) do
		if not Value then
			break;
		end
		
		if Value(Message) then
			return;
		end
	end
	
	if Message:sub(0, 3):lower() == ".ui" then
		if FireHack:IsShown() then
			FireHack:Hide();
		else
			FireHack:Show();
		end
		return;
	end
	
	if Message:sub(0, 5):lower() == ".help" or Message:sub(0, 9):lower() == ".commands" then
		print("-- |c000080B0FireHack Chat Commands|r --");
		print("|c000080B0A full list of commands is available on FH-WoW.com in the General Discussion section.|r");
		print("|c000080B0User Interface -|r .ui");
		print("|c000080B0Fly Hack -|r .fly");
		print("|c000080B0Hover Hack -|r .hover");
		print("|c000080B0Climb Hack -|r .climb");
		print("|c000080B0Waterwalk Hack -|r .waterwalk");
		print("|c000080B0No knockback Hack -|r .nk");
		print("|c000080B0Collision Hack -|r .col <M2 | WMO | Terrain | Liquid>");
		print("|c000080B0Rendering Hack -|r .ren <M2 | WMO | Terrain | Liquid>");
		print("|c000080B0Wireframe Hack -|r .wireframe");
		print("|c000080B0Stopfall Hack -|r .sf");
		return;
	end
	
	if Message:lower() == ".auctiontime" then
		if AuctionTimeHack then
			SetFHSetting("AuctionTimeHack", "false");
		else
			SetFHSetting("AuctionTimeHack", "true");
		end
		ReloadUI();
		return;
	end
	
	if Message:lower():sub(0, 9) == ".track id" then
		HandleCommand(".track name " .. Message:sub(11));
		return;
	end
	
	if Message:lower() == ".sf" or Message:lower() == ".stopfall" then
		StopFalling();
		return;
	end
	
	if Message:lower() == ".zoom" then
		if ZoomHack then
			SetFHSetting("ZoomHack", "false");
			SetCVar("cameraDistanceMax", "15");
			ZoomHack = false;
			print("|c000080B0Zoom hack disabled.|r");
		else
			SetFHSetting("ZoomHack", "true");
			SetCVar("cameraDistanceMax", "500");
			ZoomHack = true;
			print("|c000080B0Zoom hack enabled.|r");
		end
		
		return;
	end
	
	if Message:sub(0, 4):lower() == ".fly" then
		HandleCommand(Message);
		SetFlyHack(GetFlyHack());
		FireHack.Fly:SetChecked(GetFlyHack());
		return;
	end
	
	if Message:sub(0, 6):lower() == ".hover" then
		HandleCommand(Message);
		SetHoverHack(GetHoverHack());
		FireHack.Hover:SetChecked(GetHoverHack());
	end
	
	if Message:sub(0, 1) == "." then
		return HandleCommand(Message);
	else
		return SendChatMessage(Message, Channel, Language, Type);
	end
end

local ClickCallbacks = {};

-- Set a location click callback
function SetLocationClickCallback (Function)
	tinsert(ClickCallbacks, Function);
end

-- Remove a location click callback
function RemoveLocationClickCallback (Function)
	repeat
		Index, Value = next(FrameCallbacks, Index);
		if Value == Function then
			tremove(ClickCallbacks, Index);
			return;
		end
	until not Index;
end

function SignalClickCallback (X, Y, Z)
	for Index, Value in pairs(ClickCallbacks) do
		Value(X, Y, Z);
	end
	
	if TeleportToXY then
		ClickToPortHandler(X, Y, Z);
	end
end

local FrameCallbacks = {};

-- Set a frame callback
function SetFrameCallback (Function)
	tinsert(FrameCallbacks, Function);
end

-- Remove a frame callback
function RemoveFrameCallback (Function)
	repeat
		Index, Value = next(FrameCallbacks, Index);
		if Value and Value == Function then
			tremove(FrameCallbacks, Index);
			return;
		end
	until Index == nil;
end

function IsFrameCallback (Function)
	repeat
		Index, Value = next(FrameCallbacks, Index);
		if Value and Value == Function then
			return true;
		end
	until Index == nil;
	return false;
end

local TimerCallbacks = {};

-- Set a timer callback
function SetTimerCallback (Function, Interval)
	local Info = {};
	Info.Function = Function;
	Info.Interval = Interval;
	Info.Time = (GetTime() * 1000) + Interval;
	tinsert(TimerCallbacks, Info);
	return;
end

function RemoveTimerCallback (Function)
	for Index, Value in pairs(TimerCallbacks, Index) do
		if Value.Function == Function then
			tremove(TimerCallbacks, Index);
			break;
		end
	end
end

function GetTimerCallbackByIndex (Index)
	return TimerCallbacks[Index];
end

function GetTotalTimerCallbacks ()
	return #TimerCallbacks;
end

function IsTimerCallback (Function)
	for Index, Value in pairs(TimerCallbacks, Index) do
		if Value.Function == Function then
			return Value.Interval;
		end
	end
	
	return nil;
end

-- Frame callback
local LastAuctionUpdateTime = 0;
function IUpdateObjectsAndCallFrameCallbacks ()
	
	--[[if not RealSendChatMessage then
		RealSendChatMessage = SendChatMessage;
		SendChatMessage = SendChatMessageHook;
	end
	
	if not RealBNSendWhisper then
		RealBNSendWhisper = BNSendWhisper;
		BNSendWhisper = BNSendWhisperHook;
	end]]
	
	if not Player or UnitGUID("Player") ~= Player.GUID then
		Player = GetObjectFromUnitID("Player");
	end
	
	if UnitExists("Target") then
		if not Target or UnitGUID("Target") ~= Target.GUID then
			Target = GetObjectFromUnitID("Target");
		end
	else
		Target = nil;
	end
	
	if UnitExists("Focus") then
		if not Focus or UnitGUID("Focus") ~= Focus.GUID then
			Focus = GetObjectFromUnitID("Focus");
		end
	else
		Focus = nil;
	end
	
	if UnitExists("Pet") then
		if not Pet or UnitGUID("Pet") ~= Pet.GUID then
			Pet = GetObjectFromUnitID("Pet");
		end
	else
		Pet = nil;
	end
	
	for Key, Value in pairs(FrameCallbacks) do
		Value();
	end
	
	local CurrentTime = (GetTime() * 1000);
	for Key, Value in pairs(TimerCallbacks) do
		if Value.Time < CurrentTime then
			Value.Time = CurrentTime + Value.Interval;
			Value.Function();
		end
	end
	
	if AuctionTimeHack then
		-- This is to keep the hooks from being kicked (not sure why that happens though)
		GetAuctionItemTimeLeft = GetExactAuctionTimeLeft;
		AuctionFrame_GetTimeLeftText = GetTimeLeftTextHook;
		AuctionFrame_GetTimeLeftTooltipText = GetTimeLeftTooltipTextHook;
		BlackMarketScrollFrame_Update = BlackMarketScrollFrame_Update_Hook;
	end
	
	UpdateFlyAndHover();
	DoNoKnockback();
	
	if AuctionFrame and AuctionFrame:IsShown() and LastAuctionUpdateTime + 1 < GetTime() then
		AuctionFrameBrowse_Update();
		LastAuctionUpdateTime = GetTime();
	end
	
	--[[if DropDownList1Button8 and DropDownList1Button8.tooltipTitle == "Follow" and DropDownList1Button8:GetButtonState() == "DISABLED" then
		DropDownList1Button8:Enable();
	end]]
end

--[[ To fix the follow button at distances greater than 30 yards
if DropDownList1Button8 then
	DropDownList1Button8:SetScript("OnClick", function ()
		FollowUnit("Target");
	end);
end]]

-- To prevent fly and hover hack jump disconnects
local JumpOrAscendStartReal = JumpOrAscendStart;
JumpOrAscendStart = function ()
	if GetFlyHack() == true or GetHoverHack() == true then
		return;
	else
		return JumpOrAscendStartReal();
	end
end

-- Auction time hack
function GetTimeLeftTextHook (Time)	
	Time = Time / 1000;
	if Time > 172800 then
		return "Ended";
	end
	
	local Hours = math.floor(Time / 3600);
	local Minutes = math.floor((Time - Hours * 3600) / 60);
	local Seconds = math.floor(Time - Hours * 3600 - Minutes * 60);
	if Hours == 0 then
		return (Minutes .. "m " .. Seconds .. "s");
	else
		return (Hours .. "h " .. Minutes .. "m");
	end
end

function GetTimeLeftTooltipTextHook (Time)
	Time = Time / 1000;
	if Time > 172800 then
		return "Ended";
	end
	
	local Hours = math.floor(Time / 3600);
	local Minutes = math.floor((Time - Hours * 3600) / 60);
	local Seconds = math.floor(Time - Hours * 3600 - Minutes * 60);
	return (Hours .. "h " .. Minutes .. "m " .. Seconds .. "s");
end

-- Request a webpage
OnCompleteFunctions = {};
function RequestPage (URL, OnComplete)
	if type(OnComplete) == "function" then
		OnCompleteFunctions[#OnCompleteFunctions + 1] = OnComplete;
		OnComplete = "OnCompleteFunctions[" ..  #OnCompleteFunctions .. "]";
	end
	
	return IRequestPage(URL, OnComplete);
end

if AuctionTimeHack then
	GetAuctionItemTimeLeft = GetExactAuctionTimeLeft;
	AuctionFrame_GetTimeLeftText = GetTimeLeftTextHook;
	AuctionFrame_GetTimeLeftTooltipText = GetTimeLeftTooltipTextHook;
end

EventCallbacks = {};

function FireHack_OnEvent (self, event, ...)
	for Key, Value in pairs(EventCallbacks) do
		if Value.Event == event then
			Value.Function(...);
		end
	end
end

function SetEventCallback (Function, Event)
	local Info = {};
	Info.Function = Function;
	Info.Event = Event;
	tinsert(EventCallbacks, Info);
end

function RemoveEventCallback (Function)
	for Key, Value in pairs(EventCallbacks) do
		if Value.Function == Function then
			tremove(EventCallbacks, Key);
			return;
		end
	end
end

FireHackCreated = false;
if FireHackCreated then
	return;
end

FireHackCreated = true;

-- UI
FireHack = CreateFrame("Frame", "FireHack");
FireHack:ClearAllPoints();

local Backdrop = {
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	tileSize = 32,
	edgeFile = "Interface\\FriendsFrame\\UI-Toast-Border",
	tile = 1,
	edgeSize = 7,
	insets = {
		top = 2,
		right = 2,
		left = 3,
		bottom = 3,
	},
};

FireHack:SetBackdrop(Backdrop);
FireHack:SetHeight(270);
FireHack:SetWidth(140);
FireHack:SetPoint("CENTER", -200, 100);
FireHack:SetFrameStrata("HIGH");
FireHack:SetMovable(true);
FireHack:Hide();

FireHack:SetScript("OnMouseUp", function() FireHack:StopMovingOrSizing() end);
FireHack:SetScript("OnMouseDown", function() FireHack:StartMoving(); end);
--FireHack:SetScript("OnUpdate", IUpdateObjectsAndCallFrameCallbacks);

FireHack:SetScript("OnEvent", function (s, e, ...)
	for Key, Value in pairs(EventCallbacks) do
		if Value.Event == event then
			Value.Function(...);
		end
	end
end);

function UpdateHackCheckboxes ()
	if (FireHack.Climb:GetChecked() == 1) ~= GetClimbHack() then
		FireHack.Climb:SetChecked(GetClimbHack());
	end
	
	if (FireHack.WaterWalk:GetChecked() == 1) ~= GetWaterWalkHack() then
		FireHack.WaterWalk:SetChecked(GetWaterWalkHack());
	end
	
	if (FireHack.Fly:GetChecked() == 1) ~= GetFlyHack() then
		FireHack.Fly:SetChecked(GetFlyHack());
	end
	
	if (FireHack.Hover:GetChecked() == 1) ~= GetHoverHack() then
		FireHack.Hover:SetChecked(GetHoverHack());
	end
	
	if (FireHack.ObscureTarget:GetChecked() == 1) ~= GetObscureTargetHack() then
		FireHack.ObscureTarget:SetChecked(GetObscureTargetHack());
	end
	
	if (FireHack.Spectator:GetChecked() == 1) ~= GetSpectatorHack() then
		FireHack.Spectator:SetChecked(GetSpectatorHack());
	end
	
	if (FireHack.M2Collision:GetChecked() == 1) ~= GetM2Collision() then
		FireHack.M2Collision:SetChecked(GetM2Collision());
	end
	
	if (FireHack.WMOCollision:GetChecked() == 1) ~= GetWMOCollision() then
		FireHack.WMOCollision:SetChecked(GetWMOCollision());
	end
	
	if (FireHack.TerrainCollision:GetChecked() == 1) ~= GetTerrainCollision() then
		FireHack.TerrainCollision:SetChecked(GetTerrainCollision());
	end
	
	if (FireHack.LiquidCollision:GetChecked() == 1) ~= GetLiquidCollision() then
		FireHack.LiquidCollision:SetChecked(GetLiquidCollision());
	end
	
	if (FireHack.M2Rendering:GetChecked() == 1) ~= GetM2Rendering() then
		FireHack.M2Rendering:SetChecked(GetM2Rendering());
	end
	
	if (FireHack.WMORendering:GetChecked() == 1) ~= GetWMORendering() then
		FireHack.WMORendering:SetChecked(GetWMORendering());
	end
	
	if (FireHack.TerrainRendering:GetChecked() == 1) ~= GetTerrainRendering() then
		FireHack.TerrainRendering:SetChecked(GetTerrainRendering());
	end
	
	if (FireHack.LiquidRendering:GetChecked() == 1) ~= GetLiquidRendering() then
		FireHack.LiquidRendering:SetChecked(GetLiquidRendering());
	end
	
	if (FireHack.WireFrame:GetChecked() == 1) ~= GetWireFrame() then
		FireHack.WireFrame:SetChecked(GetWireFrame());
	end
	
	if (FireHack.Colliding:GetChecked() == 1) ~= GetCollidingRendering() then
		FireHack.Colliding:SetChecked(GetCollidingRendering());
	end
	
	if (FireHack.NoKnockback:GetChecked() == 1) ~= GetNoKnockbackHack() then
		FireHack.NoKnockback:SetChecked(GetNoKnockbackHack());
	end
	
	if (FireHack.MovingLoot:GetChecked() == 1) ~= GetMovingLootHack() then
		FireHack.MovingLoot:SetChecked(GetMovingLootHack());
	end
end

function FireHack_PostClick ()
	if (FireHack.Climb:GetChecked() == 1) ~= GetClimbHack() then
		SetClimbHack((FireHack.Climb:GetChecked() == 1));
	end
	
	if (FireHack.WaterWalk:GetChecked() == 1) ~= GetWaterWalkHack() then
		SetWaterWalkHack((FireHack.WaterWalk:GetChecked() == 1));
	end
	
	if (FireHack.Fly:GetChecked() == 1) ~= GetFlyHack() then
		SetFlyHack((FireHack.Fly:GetChecked() == 1));
	end
	
	if (FireHack.Hover:GetChecked() == 1) ~= GetHoverHack() then
		SetHoverHack((FireHack.Hover:GetChecked() == 1));
	end
	
	if (FireHack.ObscureTarget:GetChecked() == 1) ~= GetObscureTargetHack() then
		SetObscureTargetHack((FireHack.ObscureTarget:GetChecked() == 1));
	end
	
	if (FireHack.Spectator:GetChecked() == 1) ~= GetSpectatorHack() then
		SetSpectatorHack((FireHack.Spectator:GetChecked() == 1));
	end
	
	if (FireHack.M2Collision:GetChecked() == 1) ~= GetM2Collision() then
		SetM2Collision((FireHack.M2Collision:GetChecked() == 1));
	end
	
	if (FireHack.WMOCollision:GetChecked() == 1) ~= GetWMOCollision() then
		SetWMOCollision((FireHack.WMOCollision:GetChecked() == 1));
	end
	
	if (FireHack.TerrainCollision:GetChecked() == 1) ~= GetTerrainCollision() then
		SetTerrainCollision((FireHack.TerrainCollision:GetChecked() == 1));
	end
	
	if (FireHack.LiquidCollision:GetChecked() == 1) ~= GetLiquidCollision() then
		SetLiquidCollision((FireHack.LiquidCollision:GetChecked() == 1));
	end
	
	if (FireHack.M2Rendering:GetChecked() == 1) ~= GetM2Rendering() then
		SetM2Rendering((FireHack.M2Rendering:GetChecked() == 1));
	end
	
	if (FireHack.WMORendering:GetChecked() == 1) ~= GetWMORendering() then
		SetWMORendering((FireHack.WMORendering:GetChecked() == 1));
	end
	
	if (FireHack.TerrainRendering:GetChecked() == 1) ~= GetTerrainRendering() then
		SetTerrainRendering((FireHack.TerrainRendering:GetChecked() == 1));
	end
	
	if (FireHack.LiquidRendering:GetChecked() == 1) ~= GetLiquidRendering() then
		SetLiquidRendering((FireHack.LiquidRendering:GetChecked() == 1));
	end
	
	if (FireHack.NoKnockback:GetChecked() == 1) ~= GetNoKnockbackHack() then	
		SetNoKnockbackHack((FireHack.NoKnockback:GetChecked() == 1));
	end
	
	if (FireHack.MovingLoot:GetChecked() == 1) ~= GetMovingLootHack() then	
		SetMovingLootHack((FireHack.MovingLoot:GetChecked() == 1));
	end
	
	if (FireHack.WireFrame:GetChecked() == 1) ~= GetWireFrame() then	
		SetWireFrame((FireHack.WireFrame:GetChecked() == 1));
	end
	
	if (FireHack.Colliding:GetChecked() == 1) ~= GetCollidingRendering() then	
		SetCollidingRendering((FireHack.Colliding:GetChecked() == 1));
	end
	
	-- Incase if a hack failed to enable, make the checkbox sync up with it.
	UpdateHackCheckboxes();
end

-- Movement Hacks --

FireHack.Fly = CreateFrame("CheckButton", nil, FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.Fly:SetPoint("TOPLEFT", 66, -10);
FireHack.Fly:SetScript("PostClick", FireHack_PostClick);
FireHack.Fly:SetScale(0.8);

FireHack.FlyLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.FlyLabel:SetAllPoints();
FireHack.FlyLabel:SetText("Fly Hack");
FireHack.FlyLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.FlyLabel:SetPoint("TOPLEFT", -73, 240);

FireHack.Hover = CreateFrame("CheckButton", "Hover Hack", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.Hover:SetPoint("TOPLEFT", 145, -10);
FireHack.Hover:SetScript("PostClick", FireHack_PostClick);
FireHack.Hover:SetScale(0.8);

FireHack.HoverLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.HoverLabel:SetAllPoints();
FireHack.HoverLabel:SetText("Hover Hack");
FireHack.HoverLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.HoverLabel:SetPoint("TOPLEFT", 45, 240);

FireHack.Climb = CreateFrame("CheckButton", "Climb", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.Climb:SetPoint("TOPLEFT", 66, -35);
FireHack.Climb:SetScript("PostClick", FireHack_PostClick);
FireHack.Climb:SetScale(0.8);

FireHack.ClimbLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.ClimbLabel:SetAllPoints();
FireHack.ClimbLabel:SetText("Climb");
FireHack.ClimbLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.ClimbLabel:SetPoint("TOPLEFT", -73, 200);

FireHack.WaterWalk = CreateFrame("CheckButton", "Waterwalk", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.WaterWalk:SetPoint("TOPLEFT", 145, -35);
FireHack.WaterWalk:SetScript("PostClick", FireHack_PostClick);
FireHack.WaterWalk:SetScale(0.8);

FireHack.WaterWalkLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.WaterWalkLabel:SetAllPoints();
FireHack.WaterWalkLabel:SetText("Waterwalk");
FireHack.WaterWalkLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.WaterWalkLabel:SetPoint("TOPLEFT", 45, 200);

FireHack.ObscureTarget = CreateFrame("CheckButton", "ObscureTarget", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.ObscureTarget:SetPoint("TOPLEFT", 66, -60);
FireHack.ObscureTarget:SetScript("PostClick", FireHack_PostClick);
FireHack.ObscureTarget:SetScale(0.8);

FireHack.ObscureTargetLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.ObscureTargetLabel:SetAllPoints();
FireHack.ObscureTargetLabel:SetText("Obscure");
FireHack.ObscureTargetLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.ObscureTargetLabel:SetPoint("TOPLEFT", -73, 160);

FireHack.Spectator = CreateFrame("CheckButton", "Spectator", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.Spectator:SetPoint("TOPLEFT", 145, -60);
FireHack.Spectator:SetScript("PostClick", FireHack_PostClick);
FireHack.Spectator:SetScale(0.8);

FireHack.SpectatorLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.SpectatorLabel:SetAllPoints();
FireHack.SpectatorLabel:SetText("Spectator");
FireHack.SpectatorLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.SpectatorLabel:SetPoint("TOPLEFT", 45, 160);

FireHack.NoKnockback = CreateFrame("CheckButton", "No Knockback", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.NoKnockback:SetPoint("TOPLEFT", 115, -85);
FireHack.NoKnockback:SetScript("PostClick", FireHack_PostClick);
FireHack.NoKnockback:SetScale(0.8);

FireHack.NoKnockbackLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.NoKnockbackLabel:SetAllPoints();
FireHack.NoKnockbackLabel:SetText("No Knockback");
FireHack.NoKnockbackLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.NoKnockbackLabel:SetPoint("TOPLEFT", -15, 120);

FireHack.MovingLoot = CreateFrame("CheckButton", "Moving Loot", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.MovingLoot:SetPoint("TOPLEFT", 115, -110);
FireHack.MovingLoot:SetScript("PostClick", FireHack_PostClick);
FireHack.MovingLoot:SetScale(0.8);

FireHack.MovingLootLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.MovingLootLabel:SetAllPoints();
FireHack.MovingLootLabel:SetText("Moving Loot");
FireHack.MovingLootLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.MovingLootLabel:SetPoint("TOPLEFT", -15, 80);

-- Collision --

FireHack.CollisionLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.CollisionLabel:SetAllPoints();
FireHack.CollisionLabel:SetText("Collision");
FireHack.CollisionLabel:SetTextColor(1, 1, 1, 1);
FireHack.CollisionLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.CollisionLabel:SetPoint("TOPLEFT", 5, 40);

FireHack.M2Collision = CreateFrame("CheckButton", "M2", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.M2Collision:SetPoint("TOPLEFT", 66, -160);
FireHack.M2Collision:SetScript("PostClick", FireHack_PostClick);
FireHack.M2Collision:SetScale(0.8);

FireHack.M2CollisionLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.M2CollisionLabel:SetAllPoints();
FireHack.M2CollisionLabel:SetText("M2");
FireHack.M2CollisionLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.M2CollisionLabel:SetPoint("TOPLEFT", -73, 0);

FireHack.WMOCollision = CreateFrame("CheckButton", "WMO", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.WMOCollision:SetPoint("TOPLEFT", 145, -160);
FireHack.WMOCollision:SetScript("PostClick", FireHack_PostClick);
FireHack.WMOCollision:SetScale(0.8);

FireHack.WMOCollisionLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.WMOCollisionLabel:SetAllPoints();
FireHack.WMOCollisionLabel:SetText("WMO");
FireHack.WMOCollisionLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.WMOCollisionLabel:SetPoint("TOPLEFT", 45, 0);

FireHack.TerrainCollision = CreateFrame("CheckButton", "Terrain", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.TerrainCollision:SetPoint("TOPLEFT", 66, -185);
FireHack.TerrainCollision:SetScript("PostClick", FireHack_PostClick);
FireHack.TerrainCollision:SetScale(0.8);

FireHack.TerrainCollisionLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.TerrainCollisionLabel:SetAllPoints();
FireHack.TerrainCollisionLabel:SetText("Terrain");
FireHack.TerrainCollisionLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.TerrainCollisionLabel:SetPoint("TOPLEFT", -73, -40);

FireHack.LiquidCollision = CreateFrame("CheckButton", "Liquid", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.LiquidCollision:SetPoint("TOPLEFT", 145, -185);
FireHack.LiquidCollision:SetScript("PostClick", FireHack_PostClick);
FireHack.LiquidCollision:SetScale(0.8);

FireHack.LiquidCollisionLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.LiquidCollisionLabel:SetAllPoints();
FireHack.LiquidCollisionLabel:SetText("Liquid");
FireHack.LiquidCollisionLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.LiquidCollisionLabel:SetPoint("TOPLEFT", 45, -40);

-- Rendering --

FireHack.RenderingLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.RenderingLabel:SetAllPoints();
FireHack.RenderingLabel:SetText("Rendering");
FireHack.RenderingLabel:SetTextColor(1, 1, 1, 1);
FireHack.RenderingLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.RenderingLabel:SetPoint("TOPLEFT", 5, -80);

FireHack.M2Rendering = CreateFrame("CheckButton", "M2", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.M2Rendering:SetPoint("TOPLEFT", 66, -235);
FireHack.M2Rendering:SetScript("PostClick", FireHack_PostClick);
FireHack.M2Rendering:SetScale(0.8);

FireHack.M2RenderingLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.M2RenderingLabel:SetAllPoints();
FireHack.M2RenderingLabel:SetText("M2");
FireHack.M2RenderingLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.M2RenderingLabel:SetPoint("TOPLEFT", -73, -120);

FireHack.WMORendering = CreateFrame("CheckButton", "WMO", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.WMORendering:SetPoint("TOPLEFT", 145, -235);
FireHack.WMORendering:SetScript("PostClick", FireHack_PostClick);
FireHack.WMORendering:SetScale(0.8);

FireHack.WMORenderingLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.WMORenderingLabel:SetAllPoints();
FireHack.WMORenderingLabel:SetText("WMO");
FireHack.WMORenderingLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.WMORenderingLabel:SetPoint("TOPLEFT", 45, -120);

FireHack.TerrainRendering = CreateFrame("CheckButton", "Terrain", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.TerrainRendering:SetPoint("TOPLEFT", 66, -260);
FireHack.TerrainRendering:SetScript("PostClick", FireHack_PostClick);
FireHack.TerrainRendering:SetScale(0.8);

FireHack.TerrainRenderingLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.TerrainRenderingLabel:SetAllPoints();
FireHack.TerrainRenderingLabel:SetText("Terrain");
FireHack.TerrainRenderingLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.TerrainRenderingLabel:SetPoint("TOPLEFT", -73, -160);

FireHack.LiquidRendering = CreateFrame("CheckButton", "Liquid", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.LiquidRendering:SetPoint("TOPLEFT", 145, -260);
FireHack.LiquidRendering:SetScript("PostClick", FireHack_PostClick);
FireHack.LiquidRendering:SetScale(0.8);

FireHack.LiquidRenderingLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.LiquidRenderingLabel:SetAllPoints();
FireHack.LiquidRenderingLabel:SetText("Liquid");
FireHack.LiquidRenderingLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.LiquidRenderingLabel:SetPoint("TOPLEFT", 45, -160);

FireHack.WireFrame = CreateFrame("CheckButton", "Wireframe", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.WireFrame:SetPoint("TOPLEFT", 66, -285);
FireHack.WireFrame:SetScript("PostClick", FireHack_PostClick);
FireHack.WireFrame:SetScale(0.8);

FireHack.WireFrameLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.WireFrameLabel:SetAllPoints();
FireHack.WireFrameLabel:SetText("Wireframe");
FireHack.WireFrameLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.WireFrameLabel:SetPoint("TOPLEFT", -73, -200);

FireHack.Colliding = CreateFrame("CheckButton", "Colliding", FireHack, "ChatConfigSmallCheckButtonTemplate");
FireHack.Colliding:SetPoint("TOPLEFT", 145, -285);
FireHack.Colliding:SetScript("PostClick", FireHack_PostClick);
FireHack.Colliding:SetScale(0.8);

FireHack.CollidingLabel = FireHack:CreateFontString(nil, "HIGH", "GameFontNormal");
FireHack.CollidingLabel:SetAllPoints();
FireHack.CollidingLabel:SetText("Colliding");
FireHack.CollidingLabel:SetFont("Fonts\\ARIALN.TTF", 9, "OUTLINE");
FireHack.CollidingLabel:SetPoint("TOPLEFT", 45, -200);

FireHack.StopFallButton = CreateFrame("Button", "StopFallButton", FireHack, "UIPanelButtonTemplate");
FireHack.StopFallButton:SetPoint("CENTER", -33, -120);
FireHack.StopFallButton:SetScript("OnClick", StopFalling);
FireHack.StopFallButton:SetText("Stopfall");
FireHack.StopFallButton:SetSize(65, 20);
FireHack.StopFallButton:GetFontString():SetFont("Fonts\\ARIALN.TTF", 8, "OUTLINE");

FireHack.CameraTargetButton = CreateFrame("Button", "CameraTargetButton", FireHack, "UIPanelButtonTemplate");
FireHack.CameraTargetButton:SetPoint("CENTER", 32, -120);
FireHack.CameraTargetButton:SetScript("OnClick", function () if not Target then Player:SetAsCameraTarget(); else Target:SetAsCameraTarget() end end);
FireHack.CameraTargetButton:SetText("Camera Target");
FireHack.CameraTargetButton:SetSize(65, 20);
FireHack.CameraTargetButton:GetFontString():SetFont("Fonts\\ARIALN.TTF", 8, "OUTLINE");

FireHack:Hide();

SetEventCallback(UpdateHackCheckboxes, "HackStateChange");
UpdateHackCheckboxes();

-- Prevent the fly and hover hacks from being disabled to prevent disconnects --
-- This re-enables it the next frame when that happens --
local FlyState = GetFlyHack();
local HoverState = GetHoverHack();

local OSetFlyHack = SetFlyHack;
SetFlyHack = function (State)
	OSetFlyHack(State);
	FlyState = GetFlyHack();
end

local OSetHoverHack = SetHoverHack;
SetHoverHack = function (State)
	OSetHoverHack(State);
	HoverState = GetHoverHack();
end

function UpdateFlyAndHover ()
	if GetFlyHack() and UnitOnTaxi("Player") then
		SetFlyHack(false);
		return;
	end
	
	if GetHoverHack() and UnitOnTaxi("Player") then
		SetHoverHack(false);
		return;
	end
	
	if FlyState ~= GetFlyHack() then
		SetFlyHack(FlyState);
	end
	
	if HoverState ~= GetHoverHack() then
		SetHoverHack(HoverState);
	end
end

-- The way that the no-knockback hack works is,
-- When the knockback movement handler is called, FireHack sets NoKnockbackNextFrame to true
-- Then this function enables the fly hack (in the frame after the knockback starts)
-- Then the next frame, it's disabled again.
function DoNoKnockback ()
	if NoKnockbackNextFrame then
		SetFlyHack(true);
		DisableFlyNextFrame = true;
		NoKnockbackNextFrame = false;
		return;
	end

	if DisableFlyNextFrame then
		SetFlyHack(false);
		StopMoving();
		DisableFlyNextFrame = false;
		return;
	end
end

Packet = {};

function Packet:Allocate ()
	NewPacket = Packet;
	NewPacket.Identifier = Packet_Allocate();
	return NewPacket;
end

function Packet:Free ()
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	Packet_Free(self.Identifier);
	self.Identifier = nil;
end

function Packet:Send ()
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_Send(self.Identifier);
end

function Packet:PutByte (Value)
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_PutByte(self.Identifier, Value);
end

function Packet:PutShort (Value)
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_PutShort(self.Identifier, Value);
end

function Packet:PutInt (Value)
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_PutInt(self.Identifier, Value);
end

function Packet:PutInt64 (Value)
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_PutInt64(self.Identifier, Value);
end

function Packet:PutFloat (Value)
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_PutFloat(self.Identifier, Value);
end

function Packet:PutString (String)
	if not self.Identifier then
		error("The packet is invalid.");
	end
	
	return Packet_PutString(self.Identifier, String);
end

local BMAHItemCache = {};

function GetExactTimeLeftText (Time, BMA)
	if not BMA then
		Time = Time / 1000;
		
		if Time > 172800 then
			return "Ended";
		end
	end
	
	local Hours = math.floor(Time / 3600);
	local Minutes = math.floor((Time - Hours * 3600) / 60);
	local Seconds = math.floor(Time - Hours * 3600 - Minutes * 60);
	if Hours == 0 then
		return (Minutes .. "m " .. Seconds .. "s");
	else
		return (Hours .. "h " .. Minutes .. "m");
	end
end

function GetExactTimeLeftTooltipText (Time, BMA)
	if not BMA then
		Time = Time / 1000;
	end
	
	if Time > 172800 then
		return "Ended";
	end
	
	local Hours = math.floor(Time / 3600);
	local Minutes = math.floor((Time - Hours * 3600) / 60);
	local Seconds = math.floor(Time - Hours * 3600 - Minutes * 60);
	return (Hours .. "h " .. Minutes .. "m " .. Seconds .. "s");
end

function BlackMarketScrollFrame_Update_Hook ()
	local numItems = C_BlackMarket.GetNumItems();
	
	if not numItems then
		return;
	end
	
	local scrollFrame = BlackMarketScrollFrame;
	local offset = HybridScrollFrame_GetOffset(scrollFrame);
	local buttons = scrollFrame.buttons;
	
	if not buttons then
		return;
	end
	
	local numButtons = #buttons;

	for i = 1, numButtons do
		local button = buttons[i];
		local index = offset + i; -- adjust index

		if ( index <= numItems ) then
			local name, texture, quantity, itemType, usable, level, levelType, sellerName, minBid, minIncrement, currBid, youHaveHighBid, numBids, timeLeft, link, marketID = C_BlackMarket.GetItemInfoByIndex(index);
			
			local Cache = BMAHItemCache[name .. marketID];
			if Cache then
				timeLeft = Cache.RemainingTime - (GetTime() - Cache.FirstTime)
			else
				Cache = {};
				Cache.RemainingTime = GetExactBMATimeLeft(index);
				timeLeft = Cache.RemainingTime;
				
				Cache.FirstTime = GetTime();
				BMAHItemCache[name .. marketID] = Cache;
			end
			
			if ( name ) then
				button.Name:SetText(name);
				
				button.Item.IconTexture:SetTexture(texture);
				if ( not usable ) then
					button.Item.IconTexture:SetVertexColor(1.0, 0.1, 0.1);
				else
					button.Item.IconTexture:SetVertexColor(1.0, 1.0, 1.0);
				end

				button.Item.Count:SetText(quantity);
				button.Item.Count:SetShown(quantity > 1);
			
				button.Type:SetText(itemType);
				
				button.Seller:SetText(sellerName);
				
				button.Level:SetText(level);

				local bidAmount = currBid;
				local minNextBid = currBid + minIncrement;
				if ( currBid == 0 ) then
					bidAmount = minBid;
					minNextBid = minBid;
				end
				MoneyFrame_Update(button.CurrentBid, bidAmount);
				
				button.minNextBid = minNextBid;
				button.youHaveHighBid = youHaveHighBid;
				button.YourBid:SetShown(youHaveHighBid);
				
				button.auctionCompleate = (timeLeft == 0);
				button.TimeLeft.Text:SetText(GetExactTimeLeftText(timeLeft, true));
				button.TimeLeft.tooltip = GetExactTimeLeftTooltipText(timeLeft, true);
				
				button.itemLink = link;
				button.marketID = marketID;

				button:Show();
			else
				button:Hide()
			end
		else
			button:Hide();
		end
	end
	
	local totalHeight = numItems * scrollFrame.buttonHeight;
	local displayedHeight = numButtons * scrollFrame.buttonHeight;
	HybridScrollFrame_Update(scrollFrame, totalHeight, displayedHeight);
end

--[[function BlackMarketFrame_UpdateHotItem_Hook (self)
	local name, texture, quantity, itemType, usable, level, levelType, sellerName, minBid, minIncrement, currBid, youHaveHighBid, numBids, timeLeft, link, marketID = C_BlackMarket.GetHotItem();
	if not name then
		return;
	end
	
	local Cache = BMAHItemCache[name .. marketID];
	if Cache then
		timeLeft = Cache.RemainingTime - (GetTime() - Cache.FirstTime)
	else
		Cache = {};
		Cache.RemainingTime = GetExactBMAHotItemTimeLeft();
		timeLeft = Cache.RemainingTime;
		
		Cache.FirstTime = GetTime();
		BMAHItemCache[name .. marketID] = Cache;
	end
	
	if ( name ) then
		self.HotDeal.Name:SetText(name);
		
		self.HotDeal.Item.IconTexture:SetTexture(texture);
		if ( not usable ) then
			self.HotDeal.Item.IconTexture:SetVertexColor(1.0, 0.1, 0.1);
		else
			self.HotDeal.Item.IconTexture:SetVertexColor(1.0, 1.0, 1.0);
		end

		self.HotDeal.Item.Count:SetText(quantity);
		self.HotDeal.Item.Count:SetShown(quantity > 1);
	
		self.HotDeal.Type:SetText(itemType);
		
		self.HotDeal.Seller:SetText(sellerName);
		
		if (level > 1) then
			self.HotDeal.Level:SetText(level);
		else
			self.HotDeal.Level:SetText("");
		end
		
		local bidAmount = currBid;
		local minNextBid = currBid + minIncrement;
		if ( currBid == 0 ) then
			bidAmount = minBid;
			minNextBid = minBid;
		end
		self.HotDeal.minNextBid = minNextBid;
		self.HotDeal.youHaveHighBid = youHaveHighBid;

		if ( youHaveHighBid ) then
			MoneyInputFrame_SetCopper(BlackMarketHotItemBidPrice, currBid);
		else
			MoneyInputFrame_SetCopper(BlackMarketHotItemBidPrice, self.HotDeal.minNextBid);
		end
		
		self.HotDeal.TimeLeft.Text:SetText(GetExactTimeLeftText(timeLeft, true));
		self.HotDeal.TimeLeft.tooltip = GetExactTimeLeftTooltipText(timeLeft, true);

		self.HotDeal.itemLink = link;
		self.HotDeal.selectedMarketID = marketID;
		if ( not youHaveHighBid and GetMoney() >= self.HotDeal.minNextBid ) then
			self.HotDeal.BidButton:Enable();
		else
			self.HotDeal.BidButton:Disable();
		end
		self.HotDeal.BidButton.YourBid:SetShown(youHaveHighBid);

		self.HotDeal:Show();
	end
end]]

local LastUpdateTime = 0;
local HasHooked = false;
CreateFrame("Frame"):SetScript("OnUpdate",
	function ()
		BlackMarketScrollFrame_Update = BlackMarketScrollFrame_Update_Hook;
		--BlackMarketFrame_UpdateHotItem = BlackMarketFrame_UpdateHotItem_Hook;
		
		if BlackMarketFrame and BlackMarketFrame:IsShown() then
			if GetTime() - LastUpdateTime >= 1 then
				if not HasHooked then
					BlackMarketScrollFrame:HookScript("OnVerticalScroll", BlackMarketScrollFrame_Update_Hook);
					HasHooked = true;
				end
			
				BlackMarketScrollFrame_Update_Hook();
				--BlackMarketFrame_UpdateHotItem_Hook(BlackMarketFrame);
				LastUpdateTime = GetTime();
			end
		else
			BMAHItemCache = {};
		end
	end
);

function GetRotationBetweenPoints (X1, Y1, X2, Y2)
	if not X1 or not Y1 or not X2 or not Y2 then
		error("Usage: GetRotationBetweenPoints (X1, Y1, X2, Y2)");
	end

	return rad(atan2(Y2 - Y1, X2 - X1));
end

function GetPitchBetweenPoints (X1, Y1, Z1, X2, Y2, Z2)
	if X1 and Y1 and Z1 and X2 and Y2 and Z2 then
		return rad(atan2((Z2 - Z1) / sqrt(((X2 - X1) ^ 2) + ((Y2 - Y1) ^ 2))));
	else
		error("Usage: GetPitchBetweenPoints (X1, Y1, Z1, X2, Y2, Z2)");
	end
end

function GetDistanceBetweenPoints (X1, Y1, Z1, X2, Y2, Z2)
	if X1 and Y1 and Z1 and X2 and not Y2 and not Z2 then
		-- 2 dimensional
		return sqrt(((Z1 - X1) ^ 2) + ((X2 - Y1) ^ 2));
	elseif X1 and Y1 and Z1 and X2 and Y2 and Z2 then
		-- 3 dimensional
		return sqrt(((X2 - X1) ^ 2) + ((Y2 - Y1) ^ 2) + ((Z2 - Z1) ^ 2));
	else
		error("Usage: GetDistanceBetweenPoints (X1, Y1, Z1, X2, Y2, Z2) or GetDistanceBetweenPoints (X1, Y1, X2, Y2)");
	end
end

function GetDistanceBetweenAngles (First, Second)
	return abs(NormalizeAngle(First) - NormalizeAngle(Second));
end

function NormalizeAngle (Angle)
	return Angle % (math.pi * 2);
end

function IsPointBetween (First, Second, Point)
	local FirstToSecond = GetDistanceBetweenPoints(First[1], First[2], Second[1], Second[2]);
	local FirstToPoint = GetDistanceBetweenPoints(First[1], First[2], Point[1], Point[2]);
	local SecondToPoint = GetDistanceBetweenPoints(Second[1], Second[2], Point[1], Point[2]);
	
	return FirstToPoint <= FirstToSecond and SecondToPoint <= FirstToSecond;
end

function IsCameraBetweenPlayerAndPoint (X, Y, Z)
	local PlayerX, PlayerY, PlayerZ = Player:GetLocation();
	local CameraX, CameraY, CameraZ = GetCameraPosition();
	return IsPointBetween( { X, Y, Z }, { PlayerX, PlayerY, PlayerZ }, { CameraX, CameraY, CameraZ });
end

function WorldToScreen (X, Y, Z)
	local ScreenX, ScreenY = IWorldToScreen(X, Y, Z, WorldFrame:GetRight(), WorldFrame:GetTop());
	
	if ScreenY then
		-- Fix the Y coordinate to use WoW's UI coordinate system.
		local Height = WorldFrame:GetTop() / 2;
		
		if ScreenY < WorldFrame:GetTop() / 2 then
			ScreenY = ScreenY + (Height - ScreenY) * 2;
		else
			ScreenY = ScreenY - (ScreenY - Height) * 2;
		end
	end
	
	if not IsCameraBetweenPlayerAndPoint(X, Y, Z) and ScreenX and ScreenY and ScreenX >= 0 and ScreenX <= WorldFrame:GetRight() and ScreenY >= 0 and ScreenY <= WorldFrame:GetTop() then
		return ScreenX, ScreenY;
	else
		return nil, nil;
	end
end

if GetFHSetting("NoLoadedMessage") ~= "true" then
	print("|c000080B0FireHack loaded.|r");
end